/**
 * core.js - all global scripts belong in this file.
 */

// NAMESPACE FOR COMMON FUNCTIONS/OBJECTS
var COMMONUTILS = {
    //
    pageWidth : function () {"use strict";
        return document.documentElement.clientWidth;
    },

    // OBJ TO HOLD USERS CURRENT WEBPAGE LOCATION
    currentPage : window.location.pathname.substring (window.location.pathname.lastIndexOf ('/') + 1),

    // FUNCTION TO EXECUTE CODE BASED ON LOCATION
    userLocation : function (pagename) {"use strict";
        var page = pagename;
        $ ('#nav a').removeClass ('active');
        switch(page) {
            case 'index':
                $ ('#nav-home').addClass ('active');
                break;
            case 'about':
                $ ('#nav-about').addClass ('active');
                break;
            case 'cast':
                $ ('#nav-cast').addClass ('active');
                break;
            case 'news':
                $ ('#nav-news').addClass ('active');
                break;
            case 'reviews':
                $ ('#nav-reviews').addClass ('active');
                break;
            case 'tickets':
                $ ('#nav-tickets').addClass ('active');
                break;
            case 'gallery':
                $ ('#nav-gallery').addClass ('active');
                break;
            case 'privacy':
                $ ('#nav a').removeClass ('active');
                break;
            default:
                // No Case
                $ ('#nav-home').addClass ('active');
        }
    },

    // Create Video Boxes
    videoBox : function () {"use strict";
      $(".video-box").each(function(){
        return false;
      });
    },

    optinFormValidate: function() {
    	"use strict";

      var formName = "";

      $(".subscribe").each(function(i){

      	//console.log(i);
      	formName = "optin"+i;
      	$(this).attr("id",formName);

          //
          $(this).validate({
            rules : {
              email : { required : true, email : true }/*,
              zip : 'required'*/
            },
            messages : {
              email : 'Enter a valid email'/*,
              zip : 'Enter your zip code'*/
            },
            errorPlacement : function(error, element) {
              element.attr('placeholder', error[0].outerText);
            },
            submitHandler : function(form) {
              $.ajax({
                url : './_inc/optin_action.php',
                type : 'POST',
                data : $(form).serialize() + '&ajax=true',
                success : function() {
                  $(form).hide();
                  $(form).parent("div").append('<h3 class="text-center form-thanks">THANK YOU FOR SIGNING UP.<br /><span>Check your email to confirm your subscription.</span></h3>');
                  dataLayer.push({'event': 'signup-successful'});
                }
              });
              return false;
            }
          });

      });
    },

    nav: function() {
    	"use strict";

    	$("#btn-menu").on("click",function(e){
      	e.preventDefault();
      	if( $("#nav").hasClass("open") ){
        	$("#nav, #btn-menu").removeClass("open");
        	$("#btn-menu").removeClass("fa-times-thin").addClass("fa-bars");
      	} else {
        	$("#nav, #btn-menu").addClass("open");
        	$("#btn-menu").addClass("fa-times-thin").removeClass("fa-bars");
      	}
    	});

    },

};

//Namespace for bio functions
var bioGrid = {};

bioGrid.bioindex = 0;
bioGrid.bios = [];

bioGrid.loadBios = function (divID, page) {"use strict";
    //Cast & Creative Bios
    $(divID).load(page, null, function () {
        //
        if (divID === "#cast-bios") {
            var thumbs = "";
            for (var i=1; i <= $("#cast-bios .team-member").length; i++) {
              if (i === 6) {
                  thumbs += '<div class="cast-member actor-' + i + '" href="#' + (i - 1) + '" ><div class="cast-image">' + $('#cast-bios .team-member:nth-child(' + i + ') .castpic').html() + '</div><div class="cast-name">' + $('#cast-bios .team-member:nth-child(' + i + ') .castinfo h3 strong').html() + '</div><div class="cast-role">' + $('#cast-bios .team-member:nth-child(' + i + ') .castinfo h3 em').html() + '</div></div><br />';
              } else if ( i === 7 || i === 8 || i === 9 || i === 10 ){
                  thumbs += '<div class="cast-member actor-' + i + '" ><div class="cast-image">' + $('#cast-bios .team-member:nth-child(' + i + ') .castpic').html() + '</div><div class="cast-name">' + $('#cast-bios .team-member:nth-child(' + i + ') .castinfo h3 strong').html() + '</div><div class="cast-role">' + $('#cast-bios .team-member:nth-child(' + i + ') .castinfo h3 em').html() + '</div></div>';
              } else if (i === 5) {
                  thumbs += '<a class="cast-member actor-' + i + '" href="#' + (i - 1) + '" ><div class="cast-image">' + $('#cast-bios .team-member:nth-child(' + i + ') .castpic').html() + '</div><div class="cast-name">' + $('#cast-bios .team-member:nth-child(' + i + ') .castinfo h3 strong').html() + '</div><div class="cast-role">' + $('#cast-bios .team-member:nth-child(' + i + ') .castinfo h3 em').html() + '</div></a><br />';
                  bioGrid.bios.push($('#cast-bios .team-member:nth-child('+i+')').html());
              } else if (i === 11) {
                  thumbs += '<a class="cast-member actor-11" href="#5" ><div class="cast-image">' + $('#cast-bios .team-member:nth-child(' + i + ') .castpic').html() + '</div><div class="cast-name">' + $('#cast-bios .team-member:nth-child(' + i + ') .castinfo h3 strong').html() + '</div><div class="cast-role">' + $('#cast-bios .team-member:nth-child(' + i + ') .castinfo h3 em').html() + '</div></a>';
                  bioGrid.bios.push($('#cast-bios .team-member:nth-child('+i+')').html());
              } else {
                  thumbs += '<a class="cast-member actor-' + i + '" href="#' + (i - 1) + '" ><div class="cast-image">' + $('#cast-bios .team-member:nth-child(' + i + ') .castpic').html() + '</div><div class="cast-name">' + $('#cast-bios .team-member:nth-child(' + i + ') .castinfo h3 strong').html() + '</div><div class="cast-role">' + $('#cast-bios .team-member:nth-child(' + i + ') .castinfo h3 em').html() + '</div></a>';
                  bioGrid.bios.push($('#cast-bios .team-member:nth-child('+i+')').html());
              }


            }
        }

        $(divID).html(thumbs);

        $(divID + " .cast-member").click( function(e) {
            e.preventDefault();
            bioGrid.bioindex = Number($(this).attr("href").split("#")[1]);

            //add overlay
            $("#overlay-inner").html("").html("<div>" + bioGrid.bios [ ($(this).attr("href").split("#") [1]) ] + "</div>");
            $("html, body").addClass ("overlay-open");
            $(".overlay").addClass ("open");


            //next/prev
            $(".overlay-prev, .overlay-next").show();
            if (bioGrid.bioindex == (bioGrid.bios.length - 1)) {
                $(".overlay-next").hide();
            } else if (bioGrid.bioindex == 0) {
                $(".overlay-prev").hide();
            }

            //scroll, if necessary
            if ( $('.overlay .container').height() > $(window).height() ) {
                var slideheight = $(window).height () - $(".overlay-close").height()*2 - 100;
                $('#overlay-inner > div').slimscroll ({
                    height : slideheight + 'px', alwaysVisible : true, color : '#2dc2cd', railVisible : true, railColor : '#000'
                });
            }
        });
    })
};

//Next/Previous navigation
bioGrid.bioNav = function () {
    $(".overlay-next").click(function(e) {
        e.preventDefault();
        $(".overlay-prev").show();
        if (bioGrid.bioindex == (bioGrid.bios.length - 2)) {
            $(this).hide();
        }
        else { $(this).show(); }
        bioGrid.bioindex = bioGrid.bioindex + 1;
        $("#overlay-inner").fadeOut(300, function() {
            $(this).html(bioGrid.bios[bioGrid.bioindex]).fadeIn(500);
        });
    });

    $(".overlay-prev").click(function(e) {
        e.preventDefault();
        $(".overlay-next").show();
        if (bioGrid.bioindex == 1) {
            $(this).hide();
        }
        else { $(this).show(); }
        bioGrid.bioindex = bioGrid.bioindex - 1;
        $("#overlay-inner").fadeOut(300, function() {
            $(this).html(bioGrid.bios[bioGrid.bioindex]).fadeIn(500);
        });
    });
};

// Close Cast Overlay
bioGrid.hideOverlay = function () {
    $ (".overlay-close").click (function (e) {
        e.preventDefault ();
        $ ("html, body").removeClass ("overlay-open");
        $ (".overlay").removeClass ("open");
    });
};

// jQuery Namespace
$ (document).ready (function () {"use strict";
    $('html').addClass('page-loaded');
    COMMONUTILS.userLocation(COMMONUTILS.currentPage);
    COMMONUTILS.optinFormValidate();
    COMMONUTILS.nav();

    bioGrid.loadBios('#cast-bios','cast.html');
    bioGrid.bioNav();
    bioGrid.hideOverlay();

    $('.quote-block').slick({
      slidesToShow: 1,
      slidesToScroll: 1,
      autoplay:true,
      autoplaySpeed:3000,
      arrows:false
      //prevArrow:"<button type='button' class='slick-prev'><i class='fa fa-angle-left' aria-hidden='true'></i></button>",
      //nextArrow:"<button type='button' class='slick-next'><i class='fa fa-angle-right' aria-hidden='true'></i></button>"
    });

    $('#audible-carousel').removeClass("hide-onload").slick({
      slidesToShow: 4,
      slidesToScroll: 1,
      autoplay: true,
      autoplaySpeed: 2000,
      responsive:[
        {
          breakpoint: 767,
          settings: {
            slidesToShow: 3,
            slidesToScroll: 1
          }
        },
        {
          breakpoint: 480,
          settings: {
            slidesToShow: 2,
            slidesToScroll: 1
          }
        }
      ]
    });

    $('#gallery-overlay-inner').html( $('#gallery').html() );

    $('#gallery-overlay-inner').slick({
      slidesToShow: 1,
      slidesToScroll: 1,
      arrows: true,
      fade: true,
      asNavFor: '#gallery'
    });

    $('#gallery').slick({
      //slidesToShow: 3,
      //slidesToScroll: 1,
      //dots: true,
      asNavFor: '#gallery-overlay-inner',
      centerMode: false,
      focusOnSelect: true,
          dots: false,
          infinite: true,
          speed: 300,
          slidesToShow: 3,
          slidesToScroll: 3,
          responsive: [
            {
              breakpoint: 600,
              settings: {
                slidesToShow: 1,
                slidesToScroll: 1
              }
            }
          ]
          });

    $(document).on("click",".gallery-image",function(e){
      e.preventDefault();
      $("html").addClass('gallery-overlay-open');
    	    if( $("#gallery-overlay-close").length == 0 ){
      	    $("#gallery-overlay").append('<a id="gallery-overlay-close"></a>');
    	    }
    });

  	$(document).on("click","#gallery-overlay-close, #gallery-overlay",function(e){
  	    e.preventDefault();
      	//$("#gallery-overlay-inner").html('');
      	$("html").removeClass("gallery-overlay-open");
  	});

  	$(document).on("click","button.slick-next.slick-arrow,a.gallery-image",function(e){
  	    e.stopPropagation();
  	});

$('#gallery').on('reInit', function(){
    	$("#gallery").height( $("#gallery .slick-track").height );
    	console.log($("#gallery .slick-track").height );
});
});

// EOF
